/*
auto-generated by: https://github.com/pmndrs/gltfjsx
*/
import React, { useRef } from 'react'
import { useGLTF } from '@react-three/drei/useGLTF'
import * as THREE from 'three'

import { GLTF } from 'three/examples/jsm/loaders/GLTFLoader'
import { useTrimesh } from '@react-three/cannon'

type GLTFResult = GLTF & {
  nodes: {
    collision_mesh_park: THREE.Mesh
  }
  materials: {
    collision: THREE.MeshStandardMaterial
  }
}

export default function Model(props: JSX.IntrinsicElements['group']) {
  const group = useRef<THREE.Group>()
  const { nodes } = useGLTF('/model/plaza_collision.glb') as GLTFResult

  const material = new THREE.MeshBasicMaterial({ wireframe: true, color: 0xffff00 })

  const geometry = nodes.collision_mesh_park.geometry as THREE.BufferGeometry

  if (geometry.index === null) return null

  const vertices = geometry.attributes.position.array
  const indices = geometry.index.array

  // @ts-ignore
  const [ref] = useTrimesh(() => ({
    type: 'Static',
    position: [1.75, 1.5, 8.2],
    args: [vertices, indices],
  }))

  return (
    <group ref={group} {...props}>
      <mesh ref={ref} material={material} geometry={nodes.collision_mesh_park.geometry} />
    </group>
  )
}

useGLTF.preload('/model/plaza_collision.glb')
